exec("Add-Ons/Server_Hostbot/server.cs");
$add = true;
function servercmdadd(%c)
{
    if(!%c.isAdmin)
        return;
    if($add)
    {
        announce("sub");
        $add = false;
    }
    else
    {
        announce("add");
        $add = true;
    }
}
function serverCmdCreateBuildableVehicle(%client)
{
        if(!isObject(%player = %client.player ))
        {
            announce("no player");
            return;
        }
        if (!isObject(%vh = %player.getObjectMount()) || !(%vh.getType() & $TypeMasks::VehicleObjectType))
        {
            announce("no vehicle");
            return;
        }
        createBuildableVehicle(%client,%vh);
}

datablock StaticShapeData(VehicleBrick)
{
        category = "Static Shapes";   //Mission editor category
        item = VehicleBrick;
        shapeFile = "./BLOCK.dts";
};

function createBuildableVehicle(%client,%vehicle)
{
        %vehicle.hideNode("ALL");
        messageClient(%client,'',"\c6You will not beable to ride this vehicle until you finish building and say \c3/rideVehicle");
        %client.buildingVehicle = %vehicle;
        %vehicle.brickGroup = new SimSet();
        %vehicle.readyToRole = 0;
        locationTick(%vehicle,%vehicle.brickGroup);
}

function serverCmdridevehicle(%client)
{
        if(!isObject(%client.player))
                return;
        %vehicle = %client.player.getMountedObject(0);
        if(!isObject(%vehicle))
                return;
        %client.buildingVehicle.readyToRole = 1;
        %client.buildingVehicle = 0;
}
function setObjectRotation(%obj,%rotation)
{
        %obj.setTransform(%obj.getPosition() SPC %rotation);
}

function locationTick(%vehicle,%group)
{
        cancel($locationTick[%vehicle]);
        if(!isObject(%vehicle))
        {
            for(%i=0;%i<%group.getCount();%i++)
                %group.getObject(%i).delete();
            %group.delete();
            return;
        }
        %degree = getWord(axisToEuler(getWords(%vehicle.getTransform(),3)),2) + 180;
        %vx = getWord(%vehicle.getForwardVector(),0);
        %vy = getWord(%vehicle.getForwardVector(),1);
        %lag = vectorScale(%vehicle.getVelocity(),0.05);
        %center = %vehicle.getWorldBoxCenter();
        for(%i=0;%i<%group.getCount();%i++)
        {
                %brick = %group.getObject(%i);
                %posx = -%brick.ox;
                %posy = %brick.oy;
                %posz = %brick.oz;
                %pos = %posx * %vy + %posy * -%vx SPC %posy * -%vy + %posx * -%vx SPC %posz;
                %pos = vectorSub(%center,%pos);
                //%pos = vectorSub(%vehicle.getWorldBoxCenter(),%offset);
                %rot = %brick.rot;
                %deg = %degree + %rot;
                while(%degree >= 360)
                    %degree -= 360;
                while(%degree < 0)
                    %degree += 360;
                %deg = eulerToAxis("0 0 " @ %deg - 180);
                %brick.setTransform(%pos SPC %deg);
        }
        $locationTick[%vehicle] = schedule(33,0,locationTick,%vehicle,%group);
}

function eulerToAxis(%euler)
{
    %euler  = VectorScale(%euler,$pi / 180);
    %matrix = MatrixCreateFromEuler(%euler);
    
    return getWords(%matrix,3,6);
}

function axisToEuler(%axis)
{
    %angleOver2    = getWord(%axis,3) * 0.5;
    %angleOver2    = -%angleOver2;
    %sinThetaOver2 = mSin(%angleOver2);
    %cosThetaOver2 = mCos(%angleOver2);
    
    %q0 = %cosThetaOver2;
    %q1 = getWord(%axis,0) * %sinThetaOver2;
    %q2 = getWord(%axis,1) * %sinThetaOver2;
    %q3 = getWord(%axis,2) * %sinThetaOver2;
    
    %q0q0 = %q0 * %q0;
    %q1q2 = %q1 * %q2;
    %q0q3 = %q0 * %q3;
    %q1q3 = %q1 * %q3;
    %q0q2 = %q0 * %q2;
    %q2q2 = %q2 * %q2;
    %q2q3 = %q2 * %q3;
    %q0q1 = %q0 * %q1;
    %q3q3 = %q3 * %q3;
    
    %m13 = 2.0 * (%q1q3 - %q0q2);
    %m21 = 2.0 * (%q1q2 - %q0q3);
    %m22 = 2.0 * %q0q0 - 1.0 + 2.0 * %q2q2;
    %m23 = 2.0 * (%q2q3 + %q0q1);
    %m33 = 2.0 * %q0q0 - 1.0 + 2.0 * %q3q3;
    
    return mRadToDeg(mAsin(%m23)) SPC mRadToDeg(mAtan(-%m13,%m33)) SPC mRadToDeg(mAtan(-%m21,%m22));
}
function serverCmdreloadBV(%client)
{
    if(%client.bl_id == 8437)
        exec("./server.cs");
}
if(isPackage(BuildVehicle))
        deactivatepackage(BuildVehicle);
package BuildVehicle
{
        function serverCmdPlantBrick(%client)
        {
                if(isObject(%client.buildingvehicle))
                {
                        //%client.buildingVehicle = $BuildVehicle;
                        
                        %vehicle = %client.buildingVehicle;
                        %brick = %client.player.tempBrick;
                        %offset = vectorSub(%vehicle.getWorldBoxCenter(),%brick.getPosition());
                        //%offset = strReplace(getWord(%offset,0),"-","") SPC strReplace(getWord(%offset,1),"-","") SPC getWord(%offset,2);
                        if(vectorDist(%vehicle.getWorldBoxCenter(),%brick.getPosition()) >= 10)
                                return parent::serverCmdPlantBrick(%client);
                        %color = getColorIDTable(%brick.colorID);
                        %rot = getWord(axisToEuler(getWords(%brick.getTransform(),3)),2) + 180;
                        %degree = getWord(axisToEuler(getWords(%vehicle.getTransform(),3)),2) + 180;
                        %or = %rot - %degree;
                        %shape = new StaticShape()
                        {
                                datablock = VehicleBrick;
                                //or = %or;
                                position = %brick.getPosition();
                                rotation = %brick.rotation;
                                orgrot = %brick.rotation;
                                scale = %brick.getDatablock().bricksizeX / 2 SPC %brick.getDatablock().bricksizeY / 2 SPC %brick.getDatablock().bricksizeZ / 5;
                                ox = getWord(%offset,0);
                                oy = getWord(%offset,1);
                                oz = getWord(%offset,2);
                                rot = %or;
                        };
                        %bx = getWord(%brick.getPosition(),0);
                        %by = getWord(%brick.getPosition(),1);
                        %bz = getWord(%brick.getPosition(),2);
                        %ox = getWord(%offset,0);
                        %oy = getWord(%offset,1);
                        %oz = getWord(%offset,2);
                        //%shape.or = %or;

                        echo("---Brick Position:---");
                        echo("BX: " @ %bx @ " BY: " @ %by @ " BZ: " @ %bz);
                        echo("---Offset:---");
                        echo("OX: " @ %ox @ " OY: " @ %oy @ " OX: " @ %oz);
                        %vc = %vehicle.getWorldBoxCenter();
                        //echo(%vc);
                        echo("---Vehicle Center:---");
                        echo("VX: " @ getWord(%vc,0) @ " VY: " @ getWord(%vc,1) @ " VZ: " @ getWord(%vc,2));
                        %test = vectorAdd(%vehicle.getWorldBoxCenter(),%offset);
                        echo("---Results:---");
                        %tx = getWord(%test,0);
                        %ty = getWord(%test,1);
                        %tz = getWord(%test,2);
                        echo("TX: " @ %tx @ " TY: " @ %ty @ " TZ: " @ %tz);
                        %shape.setNodeColor("ALL",%color);
                        %vehicle.brickGroup.add(%shape);
                }
                else
                       return parent::serverCmdPlantBrick(%client);
        }
};activatepackage(Buildvehicle);

